// Fifteen.cpp: implementation of the CFifteen class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Fifteen.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFifteen::CFifteen()
{
	Init();
}

CFifteen::~CFifteen()
{

}

BOOL CFifteen::Move(int Dir)
{
	int i,j;
	switch (Dir)
	{
		case 0:
			if(y>0)
			{
				cells[x][y]=cells[x][y-1];
				y-=1;
			}
			else
				return FALSE;
			break;
		case 1:
			if(x<3)
			{
				cells[x][y]=cells[x+1][y];
				x+=1;
			}
			else
				return FALSE;
			break;
		case 2:
			if(y<3)
			{
				cells[x][y]=cells[x][y+1];
				y+=1;
			}
			else
				return FALSE;
			break;
		case 3:
			if(x>0)
			{
				cells[x][y]=cells[x-1][y];
				x-=1;
			}
			else
				return FALSE;
			break;
	}
	cells[x][y]=0;
	for(i=0;i<4;i++)
	 for(j=0;j<4;j++)
	  if(cells[i][j]!=finished[i][j])
		return FALSE;
	return TRUE;
}

void CFifteen::New()
{
	int i;
	Init();
	srand((unsigned)time(NULL));
	for(i=0;i<200;i++)
		Move(rand()/(RAND_MAX/4));
}

void CFifteen::Init()
{
	int i,j;
	for(i=0;i<4;i++)
		for(j=0;j<4;j++)
			cells[i][j] = finished[i][j];
	x = 3;
	y = 3;
}
