// Records.cpp: implementation of the CRecords class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Records.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
RecordData DefaultRecords[NRECORDS]={{"Sam Loyd",1000},{"Sam Loyd",2000},
						{"Sam Loyd",3000},{"Sam Loyd",4000},
						{"Sam Loyd",5000},{"Sam Loyd",6000},
						{"Sam Loyd",7000},{"Sam Loyd",8000},
						{"Sam Loyd",9000},{"Sam Loyd",10000}};
CRecords::CRecords()
{
	for(int i=0;i<NRECORDS;i++)
	{
		data[i].Result=DefaultRecords[i].Result;
		strcpy(data[i].Name,DefaultRecords[i].Name);
	}
}

CRecords::~CRecords()
{

}

void CRecords::Load(LPTSTR File)
{
   FILE *stream;
   stream = fopen( File, "r" );
   if( stream != NULL )
   {
	   fread(data,sizeof(RecordData),NRECORDS,stream);
	   fclose( stream );
   }
}

void CRecords::Save(LPTSTR File)
{
   FILE *stream;
   stream = fopen( File, "w" );
   if( stream != NULL )
   {
	   fwrite(data,sizeof(RecordData),NRECORDS,stream);
	   fclose( stream );
   }
}

void CRecords::Insert(LPTSTR Name, int Result)
{
	for(int i=0;i<NRECORDS;i++)
		if(Result<data[i].Result)
		{
			for(int j=NRECORDS-1;j>i;j--)
			{
				data[j].Result=data[j-1].Result;
				strcpy(data[j].Name,data[j-1].Name);
			}
			data[i].Result=Result;
			strcpy(data[i].Name,Name);
			return;
		}
}
